/*
 * @(#)NoSuchElementException.java	1.15 01/12/12
 *
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package benchmarks.dstest;

/**
 * Thrown by the <code>nextElement</code> method of an
 * <code>Enumeration</code> to indicate that there are no more
 * elements in the enumeration.
 *
 * @author unascribed
 * @version 1.15, 12/12/01
 * @see java.util.Enumeration
 * @see java.util.Enumeration#nextElement()
 * @since JDK1.0
 */
public class NoSuchElementException extends RuntimeException {
    /**
     * Constructs a <code>NoSuchElementException</code> with no detail message.
     *
     * @since JDK1.0
     */
    public NoSuchElementException() {
        super();
    }

    /**
     * Constructs a <code>NoSuchElementException</code> with the
     * specified detail message.
     *
     * @param s the detail message.
     * @since JDK1.0
     */
    public NoSuchElementException(String s) {
        super(s);
    }
}
